<?php

namespace xenarabia\BestAnswer\XF\Pub\Controller;

use XF\Pub\Controller\AbstractController;
use XF\Mvc\ParameterBag;


class ThreadAnswers extends AbstractController{

    

    public function actionIndex1(ParameterBag $params)
    {

    }



    public function actionIndex(ParameterBag $params)
    {   
        $options = \XF::options();
        $post_ba = $this->filter('post_ba', 'int');
        $threads = \XF::finder('XF:Thread')
        ->where('discussion_state', '=', 'visible')
        ->where('node_id', $params->node_id);
        if($post_ba == 0)
        {
            $threads->where('xena_post_ba', 0);
        }else{
            $threads->where('xena_post_ba', '<>', 0);
       }
        
       $threads->order('post_date','DESC');
        $threads->fetch();
        
        $forum = \XF::finder('XF:Forum')->fetch();
        $viewParams = [
            'threads'   => $threads,
            'forum'     => $forum,
             'post_ba'  => $post_ba
        ];
        
        return $this->view('xenarabia\BestAnswer\XF:Thread\View', 'ba_threads_answers', $viewParams);
    }

    protected function assertViewableForum($nodeIdOrName, array $extraWith = [])
	{
		if ($nodeIdOrName === null)
		{
			throw $this->exception($this->notFound(\XF::phrase('requested_forum_not_found')));
		}

		$visitor = \XF::visitor();
		$extraWith[] = 'Node.Permissions|' . $visitor->permission_combination_id;
		if ($visitor->user_id)
		{
			$extraWith[] = 'Read|' . $visitor->user_id;
		}

		$finder = $this->em()->getFinder('XF:Forum');
		$finder->with('Node', true)->with($extraWith);
		if (is_int($nodeIdOrName) || $nodeIdOrName === strval(intval($nodeIdOrName)))
		{
			$finder->where('node_id', $nodeIdOrName);
		}
		else
		{
			$finder->where(['Node.node_name' => $nodeIdOrName, 'Node.node_type_id' => 'Forum']);
		}

		/** @var \XF\Entity\Forum $forum */
		$forum = $finder->fetchOne();
		if (!$forum)
		{
			throw $this->exception($this->notFound(\XF::phrase('requested_forum_not_found')));
		}
		if (!$forum->canView($error))
		{
			throw $this->exception($this->noPermission($error));
		}

		$this->plugin('XF:Node')->applyNodeContext($forum->Node);

		return $forum;
    }
    
    protected function getForumViewExtraWith()
	{
		$extraWith = [];
		$userId = \XF::visitor()->user_id;
		if ($userId)
		{
			$extraWith[] = 'Watch|' . $userId;
		}

		return $extraWith;
	}
}